<template lang="pug">
title-bar {{$t("default.order_title", { id: order?.id || "" })}}
	template( #right ): b-tag( 
		:type='bindTagType' 
		:light='order && ["created", "expired", "confirmed", "payError"].includes(order.status)' size="large" ) {{$t(`default.status.${order ? order.byAdmin ? "createdByAdmin" : order.status : ""}`)}}
b-container
	.tile.is-ancestor
		.tile.is-vertical
			.tile.is-parent
				b-card.tile.is-child
					template( #icon v-if='totalPaid && totalPaid > 0' )
						.is-flex.is-align-items-center.is-justify-content-flex-end
							b-tag( :type='totalPaid == order.amount ? "success" : "danger"' )
								|{{$t("default.paid")}} ${{totalPaid}} / ${{parseInt(order.amount) + parseInt(order.amount) * .05}}
							b-button.ml-2( v-if='totalPaid < order.amount && !surchangeExist' @click='surchange' size="small" type="success" :loading='pending' ) {{$t("buttons.createPayment")}}
					order-form( :defaults='order' :has-retry='!totalPaid' @submit='submit' @cancel='cancel' @resolve='resolve' edit )
			.tile.is-parent
				b-card.tile.is-child( :title='$t("default.payments")' ): charges-table( :charges='charges' )
</template>

<script setup>
import OrderForm from "@/components/orders/Form.vue"
import ChargesTable from "@/components/orders/Charges.vue"
import BTag from "@/components/tags/Tag.vue"

import { tagClass } from "@/common/status"
import { useOrderStore } from "@/stores/order"
import { computed, onMounted, ref, watch } from "vue"
import { useRoute, useRouter } from "vue-router"

const os = useOrderStore()
const $route = useRoute()
const $router = useRouter()

const order = ref(null)

const id = computed(() => $route.params.orderId)
const pending = computed(() => os.pending)
const bindTagType = computed(() => tagClass[order.value?.status])
const charges = computed(() => {
	if (order.value?.charges) return order.value?.charges
	
	return []
})
const totalPaid = computed(() => charges.value.reduce((a, b) => {
	return a + b.payments.reduce((a, b) => {
		return a + parseFloat(b.value?.local?.amount)
	}, 0)
}, 0))
const surchangeExist = computed(() => !!charges.value.find(c => {
	// console.log(c.pricing?.local?.amount, parseFloat(order.value?.amount) + parseFloat(order.value?.amount) * .05 - totalPaid.value)
	return parseFloat(c.pricing?.local?.amount) == (parseFloat(order.value?.amount) * .05 - totalPaid.value)
}))

const fetch = async () => {
	try {
		if (id.value)
			order.value = await os.getOrder(id.value)
	} catch(err) {
		$router.push({ name: "Orders" })
	}
}

const submit = async body => {
	await os.approveOrder(id.value, body)
	await fetch()
}

const cancel = async () => {
	await os.approveOrder(id.value, { status: "canceled" })	
	await fetch()
}

const resolve = async () => {
	await os.approveOrder(id.value, { status: "confirmed" })
	await fetch()
}

const surchange = async () => {
	await os.approveOrder(id.value, { extraAmount: parseInt(order.value?.amount) + parseInt(order.value?.amount) * .05 - parseFloat(totalPaid.value) })
	await fetch()
}

watch(() => ({ ...$route.params }), fetch)
onMounted(fetch)
</script>

<style lang="scss" scoped>

</style>